// LIFO dnaamilisel massiivil C++ stiilis (klassina)

#include <stdlib.h>//#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

const int TRUE=1, FALSE=0;

class LiFo       // klassi (uue andmetbi) definitsioon
{
    int maxHigh;          
    int count;            
    int * mass;           
    char * name;          
  public:
    void init( int , char * );  
    int push( int value );
    int pop( int & value );
    void view();
};

void LiFo::init( int max, char * title )   
{
     mass = new int[max];        
      
     maxHigh = max;       
     count = 0;          
     int length = strlen(title);       
     name = new char[length+1];   
     strcpy( name, title );
}
int LiFo::push( int value )  
{
    if( count < maxHigh )   
    {
        mass[count++] = value;     
        return TRUE;
    }
    else
        return FALSE;       // overflow
}
int LiFo::pop( int & value )
{
    if( !count ) return FALSE;   // underflow  
    value = mass[--count];      //  
    return TRUE;
}
void LiFo::view()
{
    printf("\"%s\" sisaldab %d elementi:   ",name,count);
    int * p = mass;
    for( int k=0; k<count; k++ )      
       printf( "%d   ", *p++ );      // array[k]
    printf("\n");
}

//___________________________peaprogramm_____________________________________

int main()
{
    int element;
    srand( time(NULL) );    
    LiFo teine;
    LiFo magasin;
    magasin.init( 21, "Minu stack " );
    
    for( int j=0; j<8; j++ )
    {
         magasin.push( rand()%100 );         
    }
    magasin.view();
    teine.init( 21, "Teine stack" );
    while( magasin.pop( element ) )      
         teine.push( element );
         teine.view();
    getchar();
    return 0;
}
    
  
